local require = require

local pystring = require("pystring")

local mt = {}

local tostring = tostring
local format = string.format
local match = string.match
local split = pystring.split
local ioLines = io.lines

function mt.genMap(pid, filter)
    filter = filter or "x"
    local cnt = 1
    local maps = {}
    local fName = format("/proc/%s/maps", tostring(pid))
    for line in ioLines(fName) do
        local cell = split(line) -- 0066d000-0066e000 rw-p 0006d000 fd:02 147972 /usr/bin/luajit-2.0.5
        local elf = cell[6]
        if elf:sub(1, 1) == '/' then
            if filter then
                if match(cell[2], filter) then
                    maps[cnt] = {cell[1], cell[2], cell[6]}
                    cnt = cnt + 1
                end
            else
                maps[cnt] = {cell[1], cell[2], cell[6]}
                cnt = cnt + 1
            end
        end
    end
    return maps
end

return mt
