local require = require
local CplainSyms = require("haWork.plainSyms")
local gc = require("haWork.gc")
local cjson = require("cjson")

local format = string.format
local jdecode = cjson.decode
local gfree = gc.free

local syms = CplainSyms.new("sysomLiveSlaver")

local mt = {}

local function getElfs(args)
    local res = syms:getElfs(args.pid, args.elf)
    gfree()
    return res
end

local apis = {
    getElfs = getElfs,
}

function mt.plain(tReq)
    local res = jdecode(tReq.body)
    if not res then
        return {
            code = 400,
            body = "invalid request"
        }
    end

    if apis[res.api] then
        return {
            code = 200,
            body = apis[res.api](res.args)
        }
    end
    return {
        code = 400,
        body = format("invalid api unit %s", res.api)
    }
end

return mt
