---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by liaozhaoyan.
--- DateTime: 2023/10/4 11:40 PM
---

local require = require
local ffi = require("ffi")

local pystring = require("pystring")
local tonumber = tonumber
local with = pystring.with
local count = pystring.count

local function countCpuCores()
    local cpu_online_path = "/proc/cpuinfo"
    local content = with(cpu_online_path)

    return count(content, "processor")
end

local function kernelVersion()
    local info = with("/proc/version")

    local major, minor = info:match("Linux version (%d+)%.(%d+)")
    return tonumber(major), tonumber(minor)
end

local cffi
local major, minor = kernelVersion()
if major >= 5 and minor > 6 then
    cffi = ffi.load("oncpuTurbo")
else
    local cores = countCpuCores()
    if cores <= 4 then
        cffi = ffi.load("oncpu4")
    elseif cores <=16 then
        cffi = ffi.load("oncpu16")
    elseif cores <=64 then
        cffi = ffi.load("oncpu64")
    else
        cffi = ffi.load("oncpu128")
    end
end

ffi.cdef[[
typedef unsigned long addr_t;

int on_init();
int on_fire_pre();
int on_calls(void* b_in, void* b_out, struct on_stacks* keys, int* vs, unsigned int* count);
int on_call(struct on_stacks* key, struct on_stacks* next);
int on_clear_stack(void);
int on_clear_hash(struct on_stacks* key);
int on_stacks(int id, struct stack_addrs * paddr);
void on_deinit();
]]

return {ffi = ffi, cffi = cffi}
