local require = require

require("eclass")

local class = class
local CbaseModule = class("baseModule")
local system = require("common.system")
local workVar = require("module.workVar")

local error = error
local create = coroutine.create
local resume = coroutine.resume
local msleep = workVar.msleep

function CbaseModule:_init_()
    self._live = false
    self._co = nil
    print("base module init.")
end

function CbaseModule:_del_()
    if self._live then
        self:stop()
    end
    print("del.")
end

function CbaseModule:msleep(ms)
    if self._live then
        msleep(ms)
        return self._live
    else
        return false
    end
end

function CbaseModule:run(args)
    error("not implemented in baseModule")
end

function CbaseModule:start(args)
    if self._live then
        return nil, "module already started."
    end
    local co = create(self.run)
    self._live = true
    self._co = co

    local res, msg = resume(co, self, args)
    system.coReport(co, res, msg)
    return true
end

function CbaseModule:status()
    return self._live
end

function CbaseModule:stop()
    self._live = false
    return true
end

function CbaseModule:get()
    return {}
end

return CbaseModule
